// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#include "commands/Shoot.h"

#include <frc/Timer.h>

Shoot::Shoot(Gatherer &gatherer, Shooter &shooter) :
    m_gatherer(gatherer), m_shooter(shooter) {
  // Use addRequirements() here to declare subsystem dependencies.
  SetName("Shoot");
  AddRequirements({&m_gatherer, &m_shooter});
}

// Called when the command is initially scheduled.
void Shoot::Initialize() {
  m_start_time = frc::Timer::GetFPGATimestamp();
}

// Called repeatedly when this Command is scheduled to run
void Shoot::Execute() {
  bool full = frc::Timer::GetFPGATimestamp() - m_start_time > 1_s;
  m_gatherer.shoot(full);
}

// Called once the command ends or is interrupted.
void Shoot::End(bool interrupted) {
  m_gatherer.stop();
}

// Returns true when the command should end.
bool Shoot::IsFinished() {
  return false;
}
