// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#include "subsystems/Gatherer.h"

Gatherer::Gatherer() {
    m_gather_low.SetInverted(false);
    m_gather_high_back.SetInverted(true);
    m_gather_high_front.SetInverted(false);
}

// This method will be called once per scheduler run
void Gatherer::Periodic() {}

void Gatherer::gather() {
    m_gather_low.Set(ControlMode::PercentOutput, 1.0);
    m_gather_high_back.Set(ControlMode::PercentOutput, -0.6);
    m_gather_high_front.Set(ControlMode::PercentOutput, 0.6);
}

void Gatherer::eject() {
    m_gather_low.Set(ControlMode::PercentOutput, -1.0);
    m_gather_high_back.Set(ControlMode::PercentOutput, -0.6);
    m_gather_high_front.Set(ControlMode::PercentOutput, -0.6);
}

void Gatherer::shoot(bool full) {
    if(full)
        m_gather_low.Set(ControlMode::PercentOutput, 1.0);

    m_gather_high_back.Set(ControlMode::PercentOutput, 0.5);
    m_gather_high_front.Set(ControlMode::PercentOutput, 1.0);
}

void Gatherer::stop() {
    m_gather_low.Set(ControlMode::PercentOutput, 0.0);
    m_gather_high_back.Set(ControlMode::PercentOutput, 0.0);
    m_gather_high_front.Set(ControlMode::PercentOutput, 0.0);
}
