// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#include "subsystems/Shooter.h"
#include "Units.h"

#include <frc/smartdashboard/SmartDashboard.h>

Shooter::Shooter() {
    m_shooter.SetInverted(false);

    /*
    m_shooter.ConfigSelectedFeedbackSensor(FeedbackDevice::CTRE_MagEncoder_Relative, 0);
    m_shooter.SetSensorPhase(true);
    m_shooter.Config_kP(0, constants::shooter::P);
    m_shooter.Config_kI(0, constants::shooter::I);
    m_shooter.Config_kD(0, constants::shooter::D);
    */
}

void Shooter::set(units::revolutions_per_minute_t rpm) {
    rpm = rpm * constants::shooter::RATIO;
    m_shooter.Set(ControlMode::PercentOutput, rpm / constants::shooter::MAX_RPM);
    frc::SmartDashboard::PutNumber("rpm", rpm / constants::shooter::MAX_RPM);
}

bool Shooter::at_speed() {
    units::ctre_count_t counts{m_shooter.GetClosedLoopError()};
    units::revolutions_per_minute_t error{counts / 1_min / constants::shooter::RATIO};
    return error < constants::shooter::SHOOTER_TARGET_ERROR;
}

// This method will be called once per scheduler run
void Shooter::Periodic() {}
