// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#pragma once

#include <frc/PowerDistribution.h>
#include <frc/Joystick.h>
#include <frc2/command/Command.h>
#include <frc2/command/InstantCommand.h>

#include "commands/DriveWithJoysticks.h"
#include "subsystems/Chassis.h"
#include "subsystems/Shooter.h"
#include "subsystems/Gatherer.h"
#include "subsystems/Shear.h"

/**
 * This class is where the bulk of the robot should be declared.  Since
 * Command-based is a "declarative" paradigm, very little robot logic should
 * actually be handled in the {@link Robot} periodic methods (other than the
 * scheduler calls).  Instead, the structure of the robot (including subsystems,
 * commands, and button mappings) should be declared here.
 */
class RobotContainer {
 public:
  RobotContainer();

  frc2::Command* get_autonomous_command();

 private:
  // The robot's subsystems and commands are defined here...
  frc::PowerDistribution m_pdp{};

  frc::Joystick m_driver{0};
  frc::Joystick m_manip{1};

  Chassis m_chassis;
  Shooter m_shooter;
  Gatherer m_gatherer;
  Shear m_shear;

  DriveWithJoysticks m_autonomous_command;

  void map_buttons();
};
