// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#pragma once

#include "Constants.h"

#include <frc/DigitalInput.h>
#include <frc2/command/SubsystemBase.h>
#include <ctre/Phoenix.h>

class Gatherer : public frc2::SubsystemBase {
 public:
  Gatherer();

  void gather();
  void eject();
  void shoot(bool full);
  void stop();

  /**
   * Will be called periodically whenever the CommandScheduler runs.
   */
  void Periodic() override;

 private:
  // Components (e.g. motor controllers and sensors) should generally be
  // declared private and exposed only through public methods.
  TalonSRX m_gather_low{constants::can_ids::GATHER_LOW};
  TalonSRX m_gather_high_back{constants::can_ids::GATHER_HIGH_BACK};
  TalonSRX m_gather_high_front{constants::can_ids::GATHER_HIGH_FRONT};

  /*
  frc::DigitalInput m_low_sensor{constants::dio::GATHER_LOW};
  frc::DigitalInput m_high_sensor{constants::dio::GATHER_HIGH};
  */
};
