// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#pragma once

#include "Constants.h"

#include <ctre/Phoenix.h>
#include <frc2/command/SubsystemBase.h>
#include <units/angular_velocity.h>

class Shooter : public frc2::SubsystemBase {
 public:
  Shooter();

  void set(units::revolutions_per_minute_t rpm);

  bool at_speed();

  /**
   * Will be called periodically whenever the CommandScheduler runs.
   */
  void Periodic() override;

 private:
  // Components (e.g. motor controllers and sensors) should generally be
  // declared private and exposed only through public methods.
  TalonSRX m_shooter{constants::can_ids::SHOOTER};
};
